local hit_effects = require("__base__.prototypes.entity.hit-effects")

local function beam_turret_attack(inputs)
	return
	{
		layers =
		{
			{
				filename = "__scattergun_turret__/graphics/entity/hr-modular-turret.png",
				width = 136,
				height = 152,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				direction_count = 36,
				line_length = 6,
				axially_symmetrical = false,
				shift = {0.1, 0.0},
				scale = 0.5
			},
			{
				width = 68,
				height = 76,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				draw_as_shadow = true,
				direction_count = 36,
				shift = {0.3, 0.2},
				stripes =
				{
					{
						filename = "__scattergun_turret__/graphics/entity/modular-turret-shadow-1.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
					{
						filename = "__scattergun_turret__/graphics/entity/modular-turret-shadow-2.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
				},
			},
			{
				filename = "__scattergun_turret__/graphics/entity/beam-turret/hr-turret-beam.png",
				width = 172,
				height = 160,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				direction_count = 36,
				line_length = 6,
				axially_symmetrical = false,
				shift = {0.1, -0.2},
				scale = 0.5
			},
			{
				priority = "very-low",
				width = 86,
				height = 80,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				draw_as_shadow = true,
				direction_count = 36,
				shift = {0.3, 0.0},
				stripes =
				{
					{
						filename = "__scattergun_turret__/graphics/entity/beam-turret/turret-beam-shadow-1.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
					{
						filename = "__scattergun_turret__/graphics/entity/beam-turret/turret-beam-shadow-2.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
				},
			},
		}
	}
end

local function beam_turret2_attack(inputs)
	return
	{
		layers =
		{
			{
				filename = "__scattergun_turret__/graphics/entity/hr-modular-turret2.png",
				width = 140,
				height = 152,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				direction_count = 36,
				line_length = 6,
				axially_symmetrical = false,
				shift = {0.0, 0.1},
				scale = 0.5
			},
			{
				filename = "__scattergun_turret__/graphics/entity/hr-modular-turret2-mask.png",
				width = 140,
				height = 152,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				direction_count = 36,
				line_length = 6,
				shift = {0.0, 0.1},
				flags = { "mask" },
				apply_runtime_tint = true,
				scale = 0.5
			},
			{
				width = 80,
				height = 60,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				direction_count = 36,
				shift = {0.2, 0.1},
				flags = { "shadow" },
				draw_as_shadow = true,
				stripes =
				{
					{
						filename = "__scattergun_turret__/graphics/entity/modular-turret2-shadow.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
					{
						filename = "__scattergun_turret__/graphics/entity/modular-turret2-shadow.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
				},
			},
			{
				filename = "__scattergun_turret__/graphics/entity/beam-turret/hr-turret-beam.png",
				priority = "very-low",
				width = 172,
				height = 160,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				direction_count = 36,
				line_length = 6,
				axially_symmetrical = false,
				shift = {0.0, -0.2},
				scale = 0.5
			},
			{
				priority = "very-low",
				width = 86,
				height = 80,
				run_mode = inputs.run_mode or "forward",
				frame_count = inputs.frame_count or 1,
				draw_as_shadow = true,
				direction_count = 36,
				shift = {0.2, 0.0},
				stripes =
				{
					{
						filename = "__scattergun_turret__/graphics/entity/beam-turret/turret-beam-shadow-1.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
					{
						filename = "__scattergun_turret__/graphics/entity/beam-turret/turret-beam-shadow-2.png",
          					width_in_frames = inputs.frame_count or 1,
						height_in_frames = 18
					},
				},
			},
		}
	}
end

data:extend({
{
	type = "electric-turret",
	name = "w93-beam-turret",
	icon = "__scattergun_turret__/graphics/icons/beam-turret.png",
    	icon_size = 64,
	flags = {"placeable-player", "player-creation", "building-direction-8-way"},
	minable = {mining_time = 0.5, result = "w93-beam-turret"},
	max_health = 1500,
	corpse = "medium-remnants",
	collision_box = {{-1.2, -1.2 }, {1.2, 1.2}},
	selection_box = {{-1.3, -1.3 }, {1.3, 1.3}},
	damaged_trigger_effect = hit_effects.entity(),
	rotation_speed = 0.002,
	preparing_speed = 0.8,
	folding_speed = 0.8,
	dying_explosion = "medium-explosion",
	turret_base_has_direction = true,
	energy_source =

	{

		type = "electric",
		buffer_capacity = "20MJ",

		input_flow_limit = "200MW",
		drain = "74kW",

		usage_priority = "secondary-input"
	},
	resistances =
	{
		{
			type = "physical",
			decrease = 5,
			percent = 15
		},
		{
			type = "explosion",
			decrease = 80,
			percent = 50,
		},
		{
			type = "acid",
			decrease = 0,
			percent = 35,
		},
		{
			type = "fire",
			decrease = 0,
			percent = 80,
		}
	},
	folded_animation = beam_turret_attack{},
	preparing_animation = beam_turret_attack{},
	prepared_animation = beam_turret_attack{},
	attacking_animation = beam_turret_attack{},
	folding_animation = beam_turret_attack{run_mode = "backward"},

	graphics_set =
	{
		base_visualisation =
		{
			animation =
			{
				layers =
				{
					{
						filename = "__scattergun_turret__/graphics/entity/hr-modular-turret-base.png",
						priority = "high",
						width = 176,
						height = 136,
						axially_symmetrical = false,
						direction_count = 1,
						frame_count = 1,
						shift = {0.0, 0.0},
						scale = 0.5
					},
					{
						filename = "__scattergun_turret__/graphics/entity/hr-modular-turret-base-mask.png",
						flags = { "mask" },
						line_length = 1,
						width = 176,
						height = 136,
						frame_count = 1,
						axially_symmetrical = false,
						direction_count = 1,
						shift = {0.0, 0.0},
						apply_runtime_tint = true,
						scale = 0.5
					}
				}
			}
		}
	},
	fast_replaceable_group = "modular-turret-electric",
	next_upgrade = "w93-beam-turret2",
	circuit_connector = circuit_connector_definitions["w93-turret-base"],
	circuit_wire_max_distance = default_circuit_wire_max_distance,
	vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
	prepare_range = 30,
	shoot_in_prepare_state = false,
	attack_parameters =
	{
		type = "projectile",
		cooldown = 120,
		projectile_creation_distance = 0.8,
		projectile_center = {0.0, 0.4},
		range = 30,
		turn_range = 7/36,
		rotate_penalty = 1.0,
		ammo_category = "laser",
		ammo_type =
		{
			target_type = "direction",
			category = "laser",

			energy_consumption = "4.5MJ",
			clamp_position = true,
			action =
			{
				type = "line",
				range = 38,
				width = 0.7,
				range_effects =
				{
					type = "create-explosion",
					entity_name = "w93-beam"
				},
				action_delivery =
				{
					type = "instant",
					target_effects =
					{
						{
							type = "damage",
							damage = { amount = 50, type="poison" }
						},
					}
				},
			},
		},
		sound = 
		{
			{
				filename = "__scattergun_turret__/sound/beam-turret-fire.wav",
				volume = 0.55
			}
		}
	},
	call_for_help_radius = 40
},
{
	type = "electric-turret",
	name = "w93-beam-turret2",
	icon = "__scattergun_turret__/graphics/icons/beam-turret2.png",
    	icon_size = 64,
	flags = {"placeable-player", "player-creation", "building-direction-8-way"},
	minable = {mining_time = 0.5, result = "w93-beam-turret2"},
	max_health = 600,
	corpse = "medium-remnants",
	collision_box = {{-1.2, -1.2 }, {1.2, 1.2}},
	selection_box = {{-1.3, -1.3 }, {1.3, 1.3}},
	damaged_trigger_effect = hit_effects.entity(),
	rotation_speed = 0.004,
	preparing_speed = 0.8,
	folding_speed = 0.8,
	dying_explosion = "medium-explosion",
	turret_base_has_direction = true,
	energy_source =

	{

		type = "electric",
		buffer_capacity = "20MJ",

		input_flow_limit = "200MW",
		drain = "95kW",

		usage_priority = "secondary-input"
	},
	resistances =
	{
		{
			type = "acid",
			decrease = 0,
			percent = 60,
		},
		{
			type = "fire",
			decrease = 0,
			percent = 60,
		}
	},
	folded_animation = beam_turret2_attack{},
	preparing_animation = beam_turret2_attack{},
	prepared_animation = beam_turret2_attack{},
	attacking_animation = beam_turret2_attack{},
	folding_animation = beam_turret2_attack{run_mode = "backward"},
	graphics_set =
	{
		base_visualisation =
		{
			animation =
			{
				layers =
				{
					{
						filename = "__scattergun_turret__/graphics/entity/hr-modular-turret2-base.png",
						priority = "high",
						width = 160,
						height = 128,
						axially_symmetrical = false,
						direction_count = 1,
						frame_count = 1,
						shift = {0.0, 0.0},
						scale = 0.5
					},
					{
						filename = "__scattergun_turret__/graphics/entity/hr-modular-turret2-base-mask.png",
						flags = { "mask" },
						line_length = 1,
						width = 160,
						height = 128,
						frame_count = 1,
						axially_symmetrical = false,
						direction_count = 1,
						shift = {0.0, 0.0},
						apply_runtime_tint = true,
						scale = 0.5
					}
				}
			}
		}
	},
	fast_replaceable_group = "modular-turret-electric",
	next_upgrade = "w93-beam-turret",
	circuit_connector = circuit_connector_definitions["w93-turret-base2"],
	circuit_wire_max_distance = default_circuit_wire_max_distance,
	vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
	prepare_range = 50,
	shoot_in_prepare_state = false,
	attack_parameters =
	{
		type = "beam",
		cooldown = 40,
		damage_modifier = 0.5,
		range = 50,
		min_range = 20,
		turn_range = 1/3,
		source_direction_count = 36,
		source_offset = {0, 0},
		ammo_category = "beam",
		ammo_type =
		{
			category = "laser",

			energy_consumption = "1MJ",
			action =
			{
				type = "direct",
				action_delivery =
				{
					type = "beam",
					beam = "w93-electric-beam",
					max_length = 55,

			                duration = 40,

				        source_offset = {0, -0.5}
				},
			},
		},
		sound = 
		{
			filename = "__base__/sound/fight/electric-beam.ogg",
			volume = 0.7

		},
	},
	call_for_help_radius = 40
}})